
function QWFLCfor_output = QWFLC4D(input,parameters)


M = parameters.M;
mu0 = parameters.mu0;
mu1 = parameters.mu1;
t = parameters.t;
fs=parameters.Fs;

L=length(t);
tremor = quaternion(input(:,4),input(:,1),input(:,2),input(:,3));

% Quaternion WFLC variable Initialisations

N = 2*M+1;

predicted_tremor =quaternion(zeros(L,1),zeros(L,1),zeros(L,1),zeros(L,1));         % intialisaing quaternion vector in order to calulate predicted value
error=predicted_tremor;                                                            % intialising error in quaternion form

W = quaternion(zeros(N,1),zeros(N,1),zeros(N,1),zeros(N,1));                       % intialising filter weights in quaterenion form with the filter order 5
x1=quaternion(zeros(N,1),zeros(N,1),zeros(N,1),zeros(N,1));                        % Truncating input noise variable to suit the length of W
w_o = quaternion(zeros(N,1),zeros(N,1),zeros(N,1),zeros(N,1));


% QWFLC section including force

w_o(1) =  quaternion(2*pi*6/fs,2*pi*6/fs,2*pi*6/fs,2*pi*6/fs);
su=0;


for k = 1:L
    su = su+w_o(k);
    for r = 1:M
        
        S(r) = sin(r*s(su));   % 
        S(r+M)=cos(r*s(su));   % 
        
        X(r)   = sin(r*x(su));
        X(r+M) = cos(r*x(su));
        
        Y(r) = sin(r*y(su));
        Y(r+M) = cos(r*y(su));
        
        Z(r) = sin(r*z(su));
        Z(r+M) =cos(r*z(su));
        
        S(r+M+1)=1;
        X(r+M+1) = 1;
        Y(r+M+1) = 1;
        Z(r+M+1) = 1;
        
    end
    
    x1=transpose(quaternion(S,X,Y,Z));
    predicted_tremor(k) = sum(times(W,x1));                                % Estimated high frequency signal at instant k
    error(k) = tremor(k) - predicted_tremor(k);
    
    g=0;
    for r = 1:M
        g = g+r*(W(r)*x1(r+M)- W(r+M)*x1(r));
    end
    
    w_o(k+1) = w_o(k) + mu0 *( 2*times(error(k),conj(g)) - times(conj(g),conj(error(k))));
    
    W = W + mu1 *( 2*times(error(k),conj(x1)) - times(conj(x1),conj(error(k))));
end

QWFLCfor_output=[x(predicted_tremor) y(predicted_tremor) z(predicted_tremor)];




