function WFLC1D_output = WFLC1D(input,parameters)


M = parameters.M;
mu0 = parameters.mu0;
mu1 = parameters.mu1;
t = parameters.t;
fs=parameters.Fs;

tremor_x = input(:,1);
W = zeros(1,2*M+1); % Weight vector
w_o(1)=2*pi*6/fs;

sum1 = 0;

for k = 1:length(t)   
    sum1=sum1+w_o(k); 
    for r = 1:M
        X(r)   = sin(r*sum1);
        X(r+M) = cos(r*sum1);
        X(r+M+1) = 1;
    end  
    predicted_tremor_x(k)= W * X';
    error(k) = tremor_x(k) - W * X';  
    g=0; 
    for r = 1:M
        g = g+r*(W(r) * X(r+M)- W(r+M) * X(r));
    end 
    w_o(k+1) = w_o(k) + 2 * mu0 * error(k) * g;
    W = W + 2 * mu1 * X * error(k);    
end

predicted_tremor_x = predicted_tremor_x';



tremor_y = input(:,2);
W = zeros(1,2*M+1); % Weight vector
w_o(1)=2*pi*6/fs;
sum1 = 0;
for k = 1:length(t)   
    sum1=sum1+w_o(k); 
    for r = 1:M
        X(r)   = sin(r*sum1);
        X(r+M) = cos(r*sum1);
        X(r+M+1) = 1;
    end  
    predicted_tremor_y(k)= W * X';
    error(k) = tremor_y(k) - W * X';  
    g=0; 
    for r = 1:M
        g = g+r*(W(r) * X(r+M)- W(r+M) * X(r));
    end 
    w_o(k+1) = w_o(k) + 2 * mu0 * error(k) * g;
    W = W + 2 * mu1 * X * error(k);    
end

predicted_tremor_y = predicted_tremor_y';



tremor_z = input(:,3);
W = zeros(1,2*M+1); % Weight vector
w_o(1)=2*pi*6/fs;
sum1 = 0;
for k = 1:length(t)   
    sum1=sum1+w_o(k); 
    for r = 1:M
        X(r)   = sin(r*sum1);
        X(r+M) = cos(r*sum1);
        X(r+M+1) = 1;
    end  
    predicted_tremor_z(k)= W * X';
    error(k) = tremor_z(k) - W * X';  
    g=0; 
    for r = 1:M
        g = g+r*(W(r) * X(r+M)- W(r+M) * X(r));
    end 
    w_o(k+1) = w_o(k) + 2 * mu0 * error(k) * g;
    W = W + 2 * mu1 * X * error(k);    
end

predicted_tremor_z = predicted_tremor_z';




WFLC1D_output = [predicted_tremor_x predicted_tremor_y predicted_tremor_z];
